//http://sourceforge.net/project/showfiles.php?group_id=69106&package_id=67985
#define kEAGLE_VID              0x05CC
#define kEAGLE_PID_PSTFIRMWARE  0x3350
#define kEAGLE_PID_PREFIRMWARE  0x3351

int XILINXUSBWrite(Hardware *pHw, UInt16 count, UInt8 writeBuffer[])
{
    int ret = USB_ST_NOERROR;
    int retCount;
    UInt8 *xfer_buf = kmalloc(count, GFP_KERNEL);

    if (!xfer_buf)
    {
       ZAP(DEBUG_INIT, DEBUG_ERRORS, (kTAB"kmalloc for %#X bytes failed\n", count));
       ret = -ENOMEM;
       goto EZ_exit;
    }

    
    memcpy(xfer_buf, writeBuffer, count);

    ret = usb_control_msg(pHw->usbdev, 
                          usb_sndctrlpipe( pHw->usbdev, 0 ), 
                          0, 
                          USB_DIR_OUT | USB_TYPE_VENDOR | USB_RECIP_DEVICE, 
                          0x0e, 0, xfer_buf, count, 300); 
    kfree(xfer_buf);

EZ_exit:
    return ret;
}
//a envoyer quand on devient post-firmware
int loadXILINXFirmware(Hardware *pHw)
{
    int ret = USB_ST_NOERROR;
    UInt8 writeVal;
    UInt32 i=0;

    ZAP(DEBUG_INIT, DEBUG_ENTRY, ("+++loadXILINXFirmware\n"));

#define MAXSZ 64
//  18.0  CTL    00 09 01 00  SET CONFIG         50us       980.1.0
//  00 00 00 00                                980.1.4
			 
//    usb_set_configuration(pHw->usbdev, 1); 
    
    UInt32 u, ln;

    for (u = 0; u < FPGA_SIZE; ) {
      ln = FPGA_SIZE - u;
      if (ln > MAXSZ)
        ln = MAXSZ;
      ret = XILINXUSBWrite(pHw,ln, (void *)(FPGA_BIN+u));
      LOAD_ERRCHK(ret, (kTAB"XILINXUSBWrite write failure: error %x: offset %x\n", ret, u));
      u += ln;
    }
    
//  18.0  CTL    40 00 0e 00  VENDOR             46us      1697.1.0
//               01 00 00 00                               1697.1.4
			 
    ret = usb_control_msg(pHw->usbdev, 
                          usb_sndctrlpipe( pHw->usbdev, 0 ), 
                          0, 
                          USB_DIR_OUT | USB_TYPE_VENDOR | USB_RECIP_DEVICE, 
                          0xe, 0x1, NULL, 0, 300); 
    
load_exit:
    ZAP(DEBUG_INIT, DEBUG_EXIT, ("---loadXILINXFirmware\n"));
    return ret;
}
